SystemOrganization addCategory: #GODWebOld!

GODData subclass: #WEBDropdownList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBDropdownList commentStamp: 'gsc 10/7/2014 08:12' prior: 0!
A WEBDropdownList is a dropdown list HTML element. It takes a list of strings and renders a dropdown list and a submit button.
!

!WEBDropdownList class methodsFor: 'as yet unclassified' stamp: 'gsc 10/7/2014 07:31'!
values: options callback: block
	"Makes a dropdown list. options must be a collection of strings."

	^ self subclassResponsibility! !

GODData subclass: #WEBInputForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBInputForm commentStamp: 'gsc 10/7/2014 08:13' prior: 0!
A WEBInputForm is an analogue to WATextInput, or a simple text input html form.
!

!WEBInputForm class methodsFor: 'as yet unclassified' stamp: 'gsc 10/7/2014 08:16'!
value: caption callback: block
	"Analog of WATextInputTag"

	"Currently not implemented."
	"Note: must modify addOnLayoutGrid to accept all GODData subclasses, not just GODData objects."
	^ GODData new.! !

GODData subclass: #WEBPageData
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWebOld'!

WEBPageData subclass: #WEBHeaderData
	instanceVariableNames: 'text size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBHeaderData methodsFor: 'accessing' stamp: 'has 11/5/2014 09:47'!
component
	^component.! !

!WEBHeaderData methodsFor: 'initialize-release' stamp: 'has 11/5/2014 09:42'!
initialize
	super initialize.
	component := WEBHeader new.! !

WEBPageData subclass: #WEBListData
	instanceVariableNames: 'label items type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBListData methodsFor: 'accessing' stamp: 'has 10/28/2014 12:39'!
addItem: anItem
	items add: anItem.! !

!WEBListData methodsFor: 'initialize-release' stamp: 'has 10/28/2014 14:31'!
initialize
	super initialize.
	items := OrderedCollection new.! !

!WEBListData methodsFor: 'accessing' stamp: 'has 10/28/2014 14:30'!
items
	^ items.! !

!WEBListData methodsFor: 'accessing' stamp: 'has 10/28/2014 12:38'!
items: anOrderedCollection
	items := anOrderedCollection.! !

!WEBListData methodsFor: 'accessing' stamp: 'has 10/28/2014 14:30'!
label
	^ label.! !

!WEBListData methodsFor: 'accessing' stamp: 'has 10/28/2014 13:08'!
label: aString
	label:= aString.! !

!WEBListData methodsFor: 'accessing' stamp: 'has 10/28/2014 14:30'!
type
	^ type.! !

!WEBListData methodsFor: 'accessing' stamp: 'has 10/28/2014 13:08'!
type:aTypeOfList
	type:=aTypeOfList.! !

WEBPageData subclass: #WEBSubmitButtonData
	instanceVariableNames: 'label pushed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBSubmitButtonData methodsFor: 'initialize-release' stamp: 'has 11/2/2014 23:41'!
initialize
	super initialize.
	pushed:=false.! !

!WEBSubmitButtonData methodsFor: 'accessing' stamp: 'has 11/3/2014 10:11'!
label
	^ label.! !

!WEBSubmitButtonData methodsFor: 'accessing' stamp: 'has 11/2/2014 16:17'!
label: aText
	label:=aText.! !

!WEBSubmitButtonData methodsFor: 'action' stamp: 'has 11/3/2014 10:20'!
push
	pushed:=true.
	Transcript show:'push: ', pushed.
	^ pushed.! !

!WEBSubmitButtonData methodsFor: 'accessing' stamp: 'has 11/3/2014 10:12'!
pushed
	^ pushed.! !

WAComponent subclass: #WEBGodHome
	instanceVariableNames: ''
	classVariableNames: 'MainArea'
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBGodHome class methodsFor: 'accessing' stamp: 'has 11/6/2014 10:00'!
MainArea: newComponent
	MainArea:= newComponent.! !

!WEBGodHome class methodsFor: 'root' stamp: 'has 11/2/2014 12:43'!
canBeRoot
	^true.! !

!WEBGodHome class methodsFor: 'initialize-release' stamp: 'has 11/2/2014 12:45'!
initialize
	super initialize.
	self registerAsApplication: 'god'.! !

!WEBGodHome methodsFor: 'initialize-release' stamp: 'has 11/2/2014 13:28'!
initialize
	super initialize.
	MainArea:=WEBHomeView new.! !

!WEBGodHome methodsFor: 'rendering' stamp: 'has 11/2/2014 13:35'!
renderContentOn: html

	"I render the main page of GOD"
	
	html div
		id:'allcontent';
		with: [
			self
				renderHeaderOn: html;
				renderMainOn: html;
				renderFooterOn:html;
				yourself.
			].! !

!WEBGodHome methodsFor: 'rendering' stamp: 'has 11/2/2014 13:33'!
renderFooterOn: html
	html div
		id: 'footer';
		class: 'section';
		with:[
			html text: 'Object-oriented programming 2014'.
			].! !

!WEBGodHome methodsFor: 'rendering' stamp: 'has 11/5/2014 09:37'!
renderHeaderOn: html
	html div
		id: 'footer';
		class: 'section';
		with:[
			html heading: 'Grande Organizador de Dados (GOD) -- Great Data Organizer'.
			html anchor
				callback: [MainArea := WEBHomeView new];
				with: 'Home';
				yourself.
			html space.
			html anchor
				callback:[MainArea:=WEBWebGenerator new];
				with: 'GODAcademics';
				yourself.
			html space.
			html anchor
				callback:[MainArea:=WEBYApplication new];
				with: 'GODCall';
				yourself.
			html space.
			html anchor
				callback:[];
				with: 'GODConsumeAnalysis';
				yourself.
			html space.
			html anchor
				callback:[];
				with: 'GODPoliticalSentimentAnalysis';
				yourself.
			].! !

!WEBGodHome methodsFor: 'rendering' stamp: 'has 11/2/2014 13:34'!
renderMainOn: html
	html div
		id: 'main';
		class: 'section';
		with:[
			html render: MainArea.
			].! !

!WEBGodHome methodsFor: 'updating' stamp: 'has 11/2/2014 15:40'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	anHtmlRoot title: 'GOD'.
	anHtmlRoot link
		type: 'text/css';
		beStylesheet;
		addAll;
		url: WEBFileLibrary / 'god.css';
		yourself.! !

WAComponent subclass: #WEBHeader
	instanceVariableNames: 'godData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBHeader methodsFor: 'accessing' stamp: 'has 10/27/2014 07:44'!
godData
	^self godData.! !

!WEBHeader methodsFor: 'accessing' stamp: 'has 10/27/2014 07:44'!
godData: aGODData
	godData := aGODData.! !

!WEBHeader methodsFor: 'initialize-release' stamp: 'has 10/27/2014 07:51'!
initialize: aGODData
	super initialize.
	self godData: aGODData. ! !

!WEBHeader methodsFor: 'rendering' stamp: 'has 11/2/2014 12:02'!
renderContentOn: html
	html div 
		style: 'width:',godData width,
			'px; height:',godData height, 
			'px; float: left; background-color: Aqua';
		with: [html heading: godData content.].! !

WAComponent subclass: #WEBHomeView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBHomeView commentStamp: 'has 11/5/2014 09:54' prior: 0!
A WEBHomeView is component that represents the main page of GOD.
!

!WEBHomeView methodsFor: 'rendering' stamp: 'has 11/2/2014 13:18'!
renderContentOn: html
	html div
		with:[
			html heading
				level2;
				with: 'Welcome'.
				html paragraph: 'GOD is a project that captures data from several sources in internet, such as web pages and social networks. GOD processes these data and provides information for different applications: Sentimental Analysis for Consume and Politics, and Aggregators for Academic Information and Conference Information.'.
				html paragraph: 'GOD is under construction and it has been developed by the students of the Object-oriented Programming course at IME-USP'.
				html paragraph: 'Written in Smalltalk.'.
				html paragraph: 'Four applications are being developed to explore GOD...'.
			].! !

WAComponent subclass: #WEBList
	instanceVariableNames: 'godData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBList methodsFor: 'accessing' stamp: 'has 10/28/2014 12:46'!
godData
	^self godData.! !

!WEBList methodsFor: 'accessing' stamp: 'has 10/28/2014 12:48'!
godData: aGODData
	godData := aGODData.! !

!WEBList methodsFor: 'initialize-release' stamp: 'has 10/27/2014 22:44'!
initialize: aGODData
	super initialize.
	self godData: aGODData. ! !

!WEBList methodsFor: 'rendering' stamp: 'has 11/2/2014 12:03'!
renderContentOn: html
	html div 
		style: 'width:',godData width,
				'px; height:',godData height,
				'px; float: left; background-color: LightGreen';
		with:[
				html paragraph: godData label.
				html break.
				html unorderedList: [
					godData items do:[ :each | html listItem: each ]].
			].! !

WAComponent subclass: #WEBPageOld
	instanceVariableNames: 'godData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBPageOld methodsFor: 'accessing' stamp: 'djp 11/5/2014 20:17'!
add: anElement
	anElement html: html.
	elements add: anElement.! !

!WEBPageOld methodsFor: 'accessing' stamp: 'djp 11/5/2014 19:57'!
addElement: anElement
	anElement html: html.
	elements add: anElement.! !

!WEBPageOld methodsFor: 'accessing' stamp: 'has 10/27/2014 13:09'!
godData
	^self godData.! !

!WEBPageOld methodsFor: 'accessing' stamp: 'has 10/27/2014 13:09'!
godData: aGODData
	godData := aGODData.! !

!WEBPageOld methodsFor: 'accessing' stamp: 'djp 11/5/2014 19:20'!
html: anHtml
	html := anHtml! !

!WEBPageOld methodsFor: 'initialize' stamp: 'djp 11/5/2014 19:51'!
initialize
	title := 'GOD'.
	elements := OrderedCollection new.
	^self! !

!WEBPageOld methodsFor: 'initialize-release' stamp: 'has 10/27/2014 13:09'!
initialize: aGODData
	super initialize.
	self godData: aGODData. ! !

!WEBPageOld methodsFor: 'rendering' stamp: 'djp 11/5/2014 19:22'!
render: ahtml
	html := ahtml.
	self renderTitle.
	self renderElements.
! !

!WEBPageOld methodsFor: 'rendering' stamp: 'has 11/2/2014 12:01'!
renderContentOn: html
	html div 
		style: 'width:',godData width,
				'px;',godData height,
				'px; float: left; background-color: LightBlue;';
		with:[
				html text: godData content.
			].! !

!WEBPageOld methodsFor: 'rendering' stamp: 'djp 11/5/2014 20:01'!
renderElements
	elements do: [ :element | element render: html]
! !

!WEBPageOld methodsFor: 'rendering' stamp: 'djp 11/5/2014 18:49'!
renderTitle
	html heading 
		level: 1; 
		with: title.! !

!WEBPageOld methodsFor: 'accessing' stamp: 'djp 11/5/2014 18:28'!
title
	^title! !

!WEBPageOld methodsFor: 'accessing' stamp: 'djp 11/5/2014 18:23'!
title: aTitle
	title := aTitle! !

WAComponent subclass: #WEBWebGenerator
	instanceVariableNames: 'mainGodData webheader webComponents'
	classVariableNames: 'MainGodData'
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBWebGenerator class methodsFor: 'initialize-release' stamp: 'has 10/28/2014 19:21'!
initialize

	super initialize.
	self registerAsApplication: 'testApp'.! !

!WEBWebGenerator methodsFor: 'rendering' stamp: 'has 10/27/2014 13:07'!
children
	^ Array newFrom: webComponents.! !

!WEBWebGenerator methodsFor: 'component creation' stamp: 'has 11/2/2014 10:15'!
createComponent: aGODData

	"I render the web page in accord with the structure of the layoutGrid"
	
	| godDataList wrapper |
	
	1 to: aGODData layoutGrid rowCount do: [:row | 
		godDataList := OrderedCollection new.
		1 to: aGODData layoutGrid columnCount do: [:column | 
			godDataList add: (aGODData layoutGrid at: row at: column).
			].
		wrapper := WEBWrapperTable new.
		wrapper initialize: godDataList.
		webComponents add: wrapper.
		].! !

!WEBWebGenerator methodsFor: 'component creation' stamp: 'has 11/2/2014 12:13'!
createExample

	| godData headerData innerGodData anotherGodData aThirdGodData aListGodData |

	godData := GODData new.
	godData content: 'This is the content of a main GODData.'.
	godData layoutGridRowSize: 3 columnSize: 3.
	
	headerData := WEBHeaderData new.
	headerData content: 'A simple title'.
	headerData width: 400.
	headerData height: 100.
	
	innerGodData := GODData new.
	innerGodData content: 'The content presented in the web page'.
	innerGodData width: 100.
	innerGodData height: 100.
	
	anotherGodData := GODData new.
	anotherGodData content: 'Rendering another component side by side'.
	anotherGodData width: 300.
	anotherGodData height: 100.
	
	aThirdGodData := GODData new.
	aThirdGodData content: 'The third goddata to test if the rendering process is working'.
	aThirdGodData width: 400.
	aThirdGodData height: 100.
	
	aListGodData := WEBListData new.
	aListGodData label: 'A simple list'.
	aListGodData addItem: 'ICSE 09'; addItem: 'ASE 12'; addItem: 'ICSNM 11'; addItem: 'TAICPART 14'.
	aListGodData width: 1000.
	aListGodData height: 200.
	
	godData addOnLayoutGrid: headerData at: 1 at: 1.
	godData addOnLayoutGrid: innerGodData at: 2 at: 1.
	godData addOnLayoutGrid: anotherGodData at: 2 at: 2.
	godData addOnLayoutGrid: aThirdGodData at: 2 at: 3.
	godData addOnLayoutGrid: aListGodData at: 3 at: 2.
	
	self createComponent: godData.! !

!WEBWebGenerator methodsFor: 'initialize-release' stamp: 'has 11/2/2014 11:44'!
initialize

	super initialize.
	webComponents := OrderedCollection new.
	self createExample.
	! !

!WEBWebGenerator methodsFor: 'rendering' stamp: 'has 10/27/2014 13:50'!
renderContentOn: html
	"I render the web page"

	html heading: 'Hello!!'.
	html break.
	html heading: MainGodData content.
	html horizontalRule.
	webComponents do: [ :each | 
		html render: each.
		].! !

WAComponent subclass: #WEBWebGeneratorBasic
	instanceVariableNames: 'mainGodData webheader webComponents titleTest'
	classVariableNames: 'MainGodData'
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBWebGeneratorBasic class methodsFor: 'initialize-release' stamp: 'has 11/1/2014 19:08'!
initialize
	super initialize.
	self registerAsApplication: 'testAppBasic'.! !

!WEBWebGeneratorBasic methodsFor: 'rendering' stamp: 'has 11/1/2014 18:55'!
children
	^ Array newFrom: webComponents.! !

!WEBWebGeneratorBasic methodsFor: 'component creation' stamp: 'has 11/1/2014 18:59'!
createComponent: aGODData

	"I render the web page in accord with the structure of the layoutGrid"
	
	| godDataList wrapper |
	
	1 to: aGODData layoutGrid rowCount do: [:row | 
		godDataList := OrderedCollection new.
		1 to: aGODData layoutGrid columnCount do: [:column | 
			godDataList add: (aGODData layoutGrid at: row at: column).
			].
		wrapper := WEBWrapperDiv new.
		wrapper initialize: godDataList.
		webComponents add: wrapper.
		].! !

!WEBWebGeneratorBasic methodsFor: 'component creation' stamp: 'has 11/1/2014 20:02'!
createExample

	| head godData headerData innerGodData anotherGodData aThirdGodData aListGodData |

	godData := GODData new.
	godData content: 'This is the content of a main GODData.'.
	godData layoutGridRowSize: 3 columnSize: 3.
	
	headerData := WEBHeaderData new.
	headerData content: 'A simple title'.
	
	innerGodData := GODData new.
	innerGodData content: 'The content presented in the web page'.
	innerGodData width: 100.
	
	anotherGodData := GODData new.
	anotherGodData content: 'Rendering another component side by side'.
	anotherGodData width: 300.
	
	aThirdGodData := GODData new.
	aThirdGodData content: 'The third goddata to test if the rendering process is working'.
	aThirdGodData width: 400.
	
	aListGodData := WEBListData new.
	aListGodData label: 'A simple list'.
	aListGodData addItem: 'ICSE 09'; addItem: 'ASE 12'; addItem: 'ICSNM 11'; addItem: 'TAICPART 14'.
	aListGodData width: 800.
	
	godData addOnLayoutGrid: headerData at: 1 at: 1.
	godData addOnLayoutGrid: innerGodData at: 2 at: 1.
	godData addOnLayoutGrid: anotherGodData at: 2 at: 2.
	godData addOnLayoutGrid: aThirdGodData at: 2 at: 3.
	godData addOnLayoutGrid: aListGodData at: 3 at: 2.
	
	self createComponent: godData.
	
	head:= WEBWebGenerator new initialize."WEBHeader new.
	head initialize:headerData."
	titleTest:=head."'I changed the title',webComponents size."! !

!WEBWebGeneratorBasic methodsFor: 'initialize-release' stamp: 'has 11/2/2014 12:27'!
initialize

	| god |

	super initialize.
	webComponents := OrderedCollection new.
	webheader := WEBHeader new.
	god := GODData new.
	god content: 'Just a first test'.
	god width: 300.
	god height: 80.
	webheader initialize: god.
	webComponents add: webheader.
	titleTest:=webheader"'This is the main page of GOD'."
	"WAAdmin register: WEBWebGenerator asApplicationAt: 'testApp'."
	"MainGodData := GODData new."! !

!WEBWebGeneratorBasic methodsFor: 'accessing' stamp: 'has 10/27/2014 11:06'!
mainGodData
	^self mainGodData.! !

!WEBWebGeneratorBasic methodsFor: 'accessing' stamp: 'has 10/27/2014 11:06'!
mainGodData: aGodData
	mainGodData := aGodData.! !

!WEBWebGeneratorBasic methodsFor: 'rendering' stamp: 'has 11/2/2014 12:25'!
renderContentOn: html
	"I render the web page"

	html heading: 'Grande Organizador de Dados (GOD)'.
	html break.
	"html text: titleTest."
	html horizontalRule.
	html anchor 
		callback: [self createExample];
		with: '1st component'.
	html break.
	html render: titleTest.! !

WAComponent subclass: #WEBWrapperDiv
	instanceVariableNames: 'godDataList webComponents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBWrapperDiv methodsFor: 'rendering' stamp: 'has 10/29/2014 11:14'!
children
	^ Array newFrom: webComponents.! !

!WEBWrapperDiv methodsFor: 'component creation' stamp: 'has 10/29/2014 11:06'!
createComponent: aGODData

	| component |
	
	(aGODData isMemberOf: WEBHeaderData)
		ifTrue: [component := WEBHeader new.
				component initialize: aGODData.].
	(aGODData isMemberOf: WEBListData)
		ifTrue: [component := WEBList new.
				component initialize: aGODData.].
	(aGODData isMemberOf: GODData)
		ifTrue: [component := WEBPage new.
				component initialize: aGODData.].
	webComponents add:  component.! !

!WEBWrapperDiv methodsFor: 'initialize-release' stamp: 'has 10/29/2014 10:58'!
initialize: aGODDataCollection

	self initialize.
	godDataList := OrderedCollection new.
	godDataList addAll: aGODDataCollection.
	webComponents := OrderedCollection new.
	
	godDataList do: [ :each | self createComponent: each].! !

!WEBWrapperDiv methodsFor: 'rendering' stamp: 'has 10/27/2014 17:49'!
renderContentOn: html
	"I render the web page"
	html div 
		with:[
			webComponents do: [ :each | 
				html render: each.
			].
		].! !

WAComponent subclass: #WEBWrapperTable
	instanceVariableNames: 'godDataList webComponents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBWrapperTable methodsFor: 'rendering' stamp: 'has 11/2/2014 10:05'!
children
	^ Array newFrom: webComponents.! !

!WEBWrapperTable methodsFor: 'component creation' stamp: 'has 11/3/2014 07:48'!
createComponent: aGODData

	| component |
	
	(aGODData isMemberOf: WEBHeaderData)
		ifTrue: [component := WEBHeader new.
				component initialize: aGODData.].
	(aGODData isMemberOf: WEBListData)
		ifTrue: [component := WEBList new.
				component initialize: aGODData.].
	(aGODData isMemberOf: GODData)
		ifTrue: [component := WEBPage new.
				component initialize: aGODData.].
	(aGODData isMemberOf: WEBSubmitButtonData)
		ifTrue: [component := WEBSubmitButton new.
				component initialize: aGODData.].
	webComponents add:  component.! !

!WEBWrapperTable methodsFor: 'initialize-release' stamp: 'has 11/2/2014 10:05'!
initialize: aGODDataCollection

	self initialize.
	godDataList := OrderedCollection new.
	godDataList addAll: aGODDataCollection.
	webComponents := OrderedCollection new.
	
	godDataList do: [ :each | self createComponent: each].! !

!WEBWrapperTable methodsFor: 'rendering' stamp: 'has 11/2/2014 10:16'!
renderContentOn: html
	"I render the web page"
	html table:[ 
		html tableRow:[
			html tableData:[
				webComponents do: [ :each | 
					html render: each.
				].
			].
		].
	].! !

WAComponent subclass: #WEBYApplication
	instanceVariableNames: 'mainGodData application webComponents'
	classVariableNames: 'MainGodData'
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBYApplication class methodsFor: 'initialize-release' stamp: 'has 11/2/2014 17:39'!
initialize
	super initialize.! !

!WEBYApplication methodsFor: 'rendering' stamp: 'has 11/2/2014 16:42'!
children
	^ Array newFrom: webComponents.! !

!WEBYApplication methodsFor: 'component creation' stamp: 'has 11/2/2014 16:42'!
createComponent: aGODData

	"I render the web page in accord with the structure of the layoutGrid"
	
	| godDataList wrapper |
	
	1 to: aGODData layoutGrid rowCount do: [:row | 
		godDataList := OrderedCollection new.
		1 to: aGODData layoutGrid columnCount do: [:column | 
			godDataList add: (aGODData layoutGrid at: row at: column).
			].
		wrapper := WEBWrapperTable new.
		wrapper initialize: godDataList.
		webComponents add: wrapper.
		].! !

!WEBYApplication methodsFor: 'component creation' stamp: 'has 11/2/2014 16:42'!
createExample

	| godData headerData innerGodData anotherGodData aThirdGodData aListGodData |

	godData := GODData new.
	godData content: 'This is the content of a main GODData.'.
	godData layoutGridRowSize: 3 columnSize: 3.
	
	headerData := WEBHeaderData new.
	headerData content: 'A simple title'.
	headerData width: 400.
	headerData height: 100.
	
	innerGodData := GODData new.
	innerGodData content: 'The content presented in the web page'.
	innerGodData width: 100.
	innerGodData height: 100.
	
	anotherGodData := GODData new.
	anotherGodData content: 'Rendering another component side by side'.
	anotherGodData width: 300.
	anotherGodData height: 100.
	
	aThirdGodData := GODData new.
	aThirdGodData content: 'The third goddata to test if the rendering process is working'.
	aThirdGodData width: 400.
	aThirdGodData height: 100.
	
	aListGodData := WEBListData new.
	aListGodData label: 'A simple list'.
	aListGodData addItem: 'ICSE 09'; addItem: 'ASE 12'; addItem: 'ICSNM 11'; addItem: 'TAICPART 14'.
	aListGodData width: 1000.
	aListGodData height: 200.
	
	godData addOnLayoutGrid: headerData at: 1 at: 1.
	godData addOnLayoutGrid: innerGodData at: 2 at: 1.
	godData addOnLayoutGrid: anotherGodData at: 2 at: 2.
	godData addOnLayoutGrid: aThirdGodData at: 2 at: 3.
	godData addOnLayoutGrid: aListGodData at: 3 at: 2.
	
	self createComponent: godData.! !

!WEBYApplication methodsFor: 'initialize-release' stamp: 'has 11/2/2014 17:57'!
initialize
	webComponents := OrderedCollection new.
	application := GODYMain new.
	self createComponent: application createPage.
	super initialize.
	! !

!WEBYApplication methodsFor: 'purge' stamp: 'has 11/6/2014 13:22'!
initialize: aGODData
	webComponents := OrderedCollection new.
	self createComponent: (aGODData createPageAfterSubmit: aGODData).
	self initialize.
	! !

!WEBYApplication methodsFor: 'rendering' stamp: 'has 11/2/2014 16:43'!
renderContentOn: html
	"I render the web page"

	webComponents do: [ :each | 
		html render: each.
		].! !

WAFileLibrary subclass: #WEBFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBFileLibrary methodsFor: 'style' stamp: 'has 11/2/2014 13:43'!
godCss
^'body {
	font-family: 			Georgia, "Times New Roman", Times, serif;
	font-size: 			small;
}
#allcontent {
	width: 				1280px;
	padding-top: 		5px;
	padding-bottom: 	5px;
	background-color: 	#fff0d0;
	margin-left: 		auto;
	margin-right: 		auto;
}
*.section {
	background-color: 	#ffeabf;
}
#header {
	margin: 				10px;
}
#main {
	padding: 			15px;
	margin: 				0px 10px 10px 10px;
	width: 				1220px;
	float: 				left;
}
#footer {
	color: 				#204670;
	text-align: 			center;
	padding: 			15px;
	margin: 				10px;
	clear: 				right;
}'! !

Object subclass: #WEBAppManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBAppManager commentStamp: 'gsc 10/7/2014 07:53' prior: 0!
A WEBAppManager manages the bridge between GOD applications and Seaside applications.

Usage example:

See the code for WEBExampleApp.!

!WEBAppManager methodsFor: 'as yet unclassified' stamp: 'gsc 10/7/2014 07:54'!
register: appName to: obj
	"Registers appName with Seaside to refer to the object obj"
	"The object must implement the message renderContent, which must return a GODData object representing the main page being rendered"
	"The application writer must use Input Forms and Anchor links to work with the application usage flow"
	"Look at WEBExampleApp for an example class following this API."

	^ self subclassResponsibility! !

!WEBAppManager methodsFor: 'as yet unclassified' stamp: 'gsc 10/7/2014 07:29'!
unregister: appName
	"Unregisters appName from Seaside"

	^ self subclassResponsibility! !

Object subclass: #WEBExampleApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBExampleApp commentStamp: 'gsc 10/7/2014 08:11' prior: 0!
A WEBExampleApp is an example of a GOD application.

To work, your class needs to implement the renderContent message, which returns the GODData for the main page of the application.
Look at WEBExampleApp>>renderContent's source for a physical example.

This is the only requirement. All other pages are rendered through callbacks specified by you (again, see the usage of WEBInputForm as an example).

Afterwards, you would run:

WEBAppManager register: 'Example Application' to: WEBExampleApp.

Which would then register the appropriate application to Seaside, and it would start to work!!

NOTE: This class has been excluded from our class diagram since it is only an example.
!

!WEBExampleApp methodsFor: 'creating' stamp: 'has 10/29/2014 10:34'!
createExample1

	| generator godData headerData innerGodData anotherGodData aThirdGodData aListGodData |

	godData := GODData new.
	godData content: 'This is the content of a main GODData.'.
	godData layoutGridRowSize: 3 columnSize: 3.
	
	headerData := WEBHeaderData new.
	headerData content: 'A simple title'.
	
	innerGodData := GODData new.
	innerGodData content: 'The content presented in the web page'.
	innerGodData width: 100.
	
	anotherGodData := GODData new.
	anotherGodData content: 'Rendering another component side by side'.
	anotherGodData width: 300.
	
	aThirdGodData := GODData new.
	aThirdGodData content: 'The third goddata to test if the rendering process is working'.
	aThirdGodData width: 400.
	
	aListGodData := WEBListData new.
	aListGodData label: 'A simple list'.
	aListGodData addItem: 'ICSE 09'; addItem: 'ASE 12'; addItem: 'ICSNM 11'; addItem: 'TAICPART 14'; addItem: 'NAPSoL 14'.
	aListGodData width: 800.
	
	godData addOnLayoutGrid: headerData at: 1 at: 1.
	godData addOnLayoutGrid: innerGodData at: 2 at: 1.
	godData addOnLayoutGrid: anotherGodData at: 2 at: 2.
	godData addOnLayoutGrid: aThirdGodData at: 2 at: 3.
	godData addOnLayoutGrid: aListGodData at: 3 at: 2.
	
	generator := WEBWebGeneratorNew.
	generator initializeWith: godData.! !

!WEBExampleApp methodsFor: 'as yet unclassified' stamp: 'gsc 10/7/2014 08:08'!
renderContent
	"This function gets called by the WEBAppManager to render the application's main page"
	
	| page a b c |
	page := GODData new.
	"page will be our main container, using a 3x1 matrix"
	"If we initialize layoutGrid, then a's content will NOT be rendered"
	"The layoutGrid is used only in GODData elements which contain other GODData elements (and not any real content)"
	page layoutGridRowSize: 3 columnSize: 1.
	
	a := GODData new.
	a content: 'Example Application'.
	"If unset, the height or width are automatically calculated."
	a height: 300.
	page addOnLayoutGrid: a at: 1 at: 1.
	
	b := GODData new.
	b title: 'User info example'.
	b content: 'Username: joao
Name: Joao'.
	page addOnLayoutGrid: b at: 2 at: 1.
	
	"Here we create a WEBInputForm to get some user input, and pass the callback to render the page when the user submits the form."
	c := WEBInputForm value: 'Example:' callback: [ :input | ^ self renderSecondPage: input. ].
	page addOnLayoutGrid: c at: 3 at: 1.
	
	"We return the GODData to be rendered for the main page."
	^ page.
	
	
	
! !

!WEBExampleApp methodsFor: 'as yet unclassified' stamp: 'gsc 10/7/2014 08:08'!
renderSecondPage: input
	"This function renders the App's second page, and receives some user input."

	| page title content |
	page := GODData new.
	page layoutGridRowSize: 2 columnSize: 1.
	
	title := GODData new.
	title content: 'Example Application'.
	page addOnLayoutGrid: title at: 1 at: 1.
	
	content := GODData new.
	content title: 'Received input:'.
	content content: input.
	page addOnLayoutGrid: content at: 2 at: 1.
	
	^ page.! !

Object subclass: #WEBWebPageFetcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWebOld'!

!WEBWebPageFetcher commentStamp: 'gsc 10/7/2014 08:13' prior: 0!
A WEBWebPageFetcher downloads URLs and returns its raw contents.

See the class method fetch:.
!

!WEBWebPageFetcher class methodsFor: 'as yet unclassified' stamp: 'has 11/4/2014 08:57'!
fetch: url
	"Returns a MIMEDocument object representing the downloaded file of the given URL. url is a string"

	| response |
	response := [WebClient new httpGet: url]
	
	"Ignore all certificate issues when using HTTPS/SSL"
	on: SqueakSSLCertificateError do: [:ex | ex resume].
	
	^response content! !
WEBGodHome initialize!
WEBWebGenerator initialize!
WEBWebGeneratorBasic initialize!
WEBYApplication initialize!
